from z3 import *
from random import randint
import time
import random
import string
import statistics

def randomString(stringLength=8):
    letters = string.ascii_lowercase
    return ''.join(random.choice(letters) for i in range(stringLength))

communicationCost = Real('communicationCost')
communicationCostDown = Real('communicationCostDown')
computationCost = Real('computationCost')
communicationTime = Real('communicationTime')
computationTime = Real('computationTime')


communicationCostOpt = Real('communicationCostOpt')
communicationCostDownOpt = Real('communicationCostDownOpt')
computationCostOpt = Real('computationCostOpt')
communicationTimeOpt = Real('communicationTimeOpt')
computationTimeOpt = Real('computationTimeOpt')

nUsers = 1
nConstraints = 2


#{task, node}
globalEnergyMean = []
globalEnergyStd = []
globalTimeMean = []
globalTimeStd = []
energyValues = []
timeValues = []
for row in range(3):
	row = 0
	nTask = 10 + 20*row
	energyValues.clear()
	timeValues.clear()

	for experiment in range(4):

		nFeaturesLocated = round(nTask*random.uniform(0.20,0.30))
		nFeatures = nTask - nFeaturesLocated
		nConstraints = round(random.uniform(0.1,0.3)*nFeatures)
		nNodes = 20 + 10 * row

		objectives = random.uniform(0,100)
		Objectives = {''}
		if objectives < 33:
			Objectives.add('energy')
		elif objectives > 33 and objectives < 66:
			Objectives.add('latency')
		elif  objectives > 66:
			Objectives.add('energy')
			Objectives.add('latency')

		assignment = [ [ Bool("ASING_%s_%s" % (r,c)) for c in range(nNodes+nUsers-1) ] 
				for r in range(nTask*nUsers) ]

		assignmentOpt = [ [ Bool("ASING_%s_%s" % (r,c)) for c in range(nNodes+nUsers-1) ] 
				for r in range(nTask*nUsers) ]


		#data to be transmitted between tasks
		relation = [ [ 0 for c in range(nTask) ] 
		      for r in range(nTask) ]

		for n in range(nFeatures - 1):
			relation[nFeaturesLocated + n][nFeaturesLocated+ n+1] = random.uniform(30/8,30000/8)

		tasks = [ [ 0 for c in range(9) ] 
		      for r in range(nTask) ]

		nodes = [ [ 0 for c in range(14) ] 
		      for r in range(nNodes) ]


		def randomString(stringLength=2):
		    letters = string.ascii_lowercase
		    return ''.join(random.choice(letters) for i in range(stringLength))	
		
		for x in range(0, nFeaturesLocated):
			location = randomString()
			tasks[x][0] = 2
			tasks[x][1] = 2
			tasks[x][2] = x
			tasks[x][3] = 0
			tasks[x][4] = {''}
			tasks[x][5] = {''}
			tasks[x][6] = {}
			tasks[x][7] = location
			tasks[x][8] = 'mote'

			nodes[x][0] = 10
			nodes[x][1] = 10
			nodes[x][2] = 0.1
			nodes[x][3] = 0.00023
			nodes[x][4] = 6000
			nodes[x][6] = 0.1
			nodes[x][7] = 250000000
			nodes[x][8] = {''}
			nodes[x][9] = {''}
			nodes[x][10] = 'mote'
			nodes[x][11] = location
			nodes[x][12] = 'public'
			nodes[x][13] = {'wlan'}

		#{0-CPU, 1-RAM, 2-transmission, 3-sensingRequirements, 4-peripheral requirements, 5-transmit, 6-exactLocation, 7 type }
		for x in range(nFeaturesLocated, nTask):
			tasks[x][0] = random.uniform(12000,240000)
			tasks[x][1] = random.uniform(10,1000)
			tasks[x][2] = x
			tasks[x][3] = 0
			tasks[x][4] = {''}
			tasks[x][5] = {''}
			tasks[x][6] = {}
			tasks[x][7] = 'none'
			tasks[x][8] = 'computing'
			print('tasks en un lugar' + str(nFeaturesLocated))

		#{CPU, Bandwidth. Power Upload, k, RAM, policy, Power Download, BandwidthDown,sensing units, peripherals, type, location, owner}
		for x in range(nFeaturesLocated, nNodes):
			nodes[x][0] = random.uniform(1000000000,2400000000)
			nodes[x][1] = random.uniform(100000000,200000000)
			nodes[x][2] = random.uniform(0.3,0.4)
			nodes[x][3] = random.uniform(0.0000004,0.0000009)
			nodes[x][4] = random.uniform(2000,6000)
			nodes[x][6] = random.uniform(0.2,0.4)
			nodes[x][7] = random.uniform(150000000,200000000)
			nodes[x][8] = {''}
			nodes[x][9] = {''}
			nodes[x][10] = 'computing'
			nodes[x][11] = 'anyplace'
			nodes[x][12] = 'public'
			nodes[x][13] = {'wlan'}

		#Edges of the task-call graph
		constraints = [ [ 0 for c in range(nTask) ] 
		      for r in range(nConstraints) ]

		#[0] max time to be executed
		#[1] number of tasks involved in the restriction
		#[2...n] index of the involved tasks
		#create random time restrictions 
		for n in range(nConstraints):
			aux = round(random.uniform(0.2,0.5)*nFeatures)
			constraints[n][0] = random.uniform(10,15)
			constraints[n][1] = aux
			featureIni = random.uniform(0,nFeatures-aux)
			for x in range(aux):
				constraints[n][aux+2] = x + featureIni + nFeaturesLocated
				

		def getDistance(lat1,lon1,lat2,lon2,connectivity, range):
				R = 6373.0
				dlon = lon2 - lon1
				dlat = lat2 - lat1

				a = sin(dlat / 2)**2 + cos(lat1) * cos(lat2) * sin(dlon / 2)**2
				c = 2 * atan2(sqrt(a), sqrt(1 - a))

				distance = R * c
				available = distance < range

				return available


		def numberUsers(RAMSolution):
			minimum = 99999999
			for n in range(1, nNodes):
				if nodes[n][10] == 'computing' and RAMSolution[n] > 0:
					ram = RAMSolution[n]
					if len(nodes[n][11]) <= 3:
						for t in range(nTask):
							if tasks[t][7] == nodes[n][11]:
								ram = ram - tasks[t][1]
					if ram > 0:
							relation = round(nodes[n][4]/ram)
							if relation < minimum:
								minimum = relation
			return minimum


		#configuring the policy (user node)
		for x in range(nUsers):
			nodes[x][5] = 1

		#configuring the policy (rest of nodes). All nodes has been configured with the same node weighting (1)
		for x in range(nUsers, nNodes):
			nodes[x][5] = 1


		timeBefore = time.time()

		opt = Optimize()

		opt.add([Sum([If(assignment [t][m] ,1,0) for m in range(nNodes)]) == 1 for t in range(nTask*nUsers)])
		for t in range(nTask):
			opt.add(Sum([If(assignment [t][node] ,  ((tasks[t][7] == 'none') + (tasks[t][7] == nodes[node][11])),1) for node in range(nNodes)]) == nNodes)
			opt.add(Sum([If(assignment [t][node] ,  ((tasks[t][8] == nodes[node][10])),1) for node in range(nNodes)]) == nNodes)


		#RAM assignment for each node and user
		for u in range(0, nUsers):
			opt.add([Sum([assignment[t+nTask*u][m]*tasks[t+nTask*u][1] for t in range(nTask)]) <= nodes[m][4] for m in range(nNodes)])

		#time restrictions
		for c in range(0, nConstraints):
			opt.add([(Sum([simplify(assignment[constraints[c][i]+(u*nTask)][m]*If(assignment[constraints[c][j]+(u*nTask)][m],0,1)*relation[constraints[c][i]][constraints[c][j]]*1000000/nodes[m][1])for j in range(2, 2 + constraints[c][1])]) + (assignment[constraints[c][i]+(u*nTask)][m]*tasks[constraints[c][i]+(u*nTask)][0]/nodes[m][0]))*1000000 <= constraints[c][0]*1000000 for i in range(2, 2 + constraints[c][1])  for m in range(nNodes) for u in range(nUsers)])

		#if 'energy' in Objectives:
		opt.add(communicationCost == Sum([Sum([Sum([Sum([simplify(assignment[i + u*nTask][m]*If(assignment[j+ u*nTask][m],0,1)*(nodes[m][2]*(relation[i][j]/nodes[m][1])*nodes[m][5])) for j in range(nTask)]) for i in range(nTask)]) for u in range(nUsers)]) for m in range(nNodes)]))
		opt.add(computationCost == Sum([Sum([simplify(assignment[i][m] * nodes[m][3] * tasks[i][0] * (nodes[m][0]**2) *nodes[m][5]) for i in range(nTask*nUsers)]) for m in range(nNodes)]))
		#	opt.minimize(communicationCost + computationCost)
		#
		#if 'latency' in Objectives:
		opt.add(computationTime == Sum([Sum([If(assignment[t][m], tasks[t][0]/nodes[m][0],0) for t in range(nTask)]) for m in range (nNodes)]))
		opt.add(communicationTime == Sum([Sum([Sum([Sum([simplify(If(assignment[i + u*nTask][m] * If(assignment[j+ u*nTask][m],0,1) == 1,relation[i][j]/nodes[m][1],0)) for j in range(nTask)]) for i in range(nTask)]) for u in range(nUsers)]) for m in range(nNodes)]) )
		#pt.minimize(computationTime + communicationTime)

		#print('Minimizing ' + str(Objectives))

		sat = opt.check()
		m = opt.model()
		timeAfter = time.time()
		print('**************************')
		print(str(sat) + ' tasks: ' + str(nTask) + ' :' + str(timeAfter-timeBefore))

		#for t in range (nTask):
		#	for n in range (nNodes):
		#		if str(m[assignment[t][n]]) == 'True':
		#			print('Task ' + str(t) + ' assigned to device ' + str(n))
		#ramNodes = []		
		#for n in range (nNodes):
		#	ram = round(m[RAMresources[n][0]].numerator_as_long()/m[RAMresources[n][0]].denominator_as_long())
		#	ramNodes.append(ram)
		#	if ram > 1:
		#		print('RAM allocated in node ' + str(n) + ': ' + str(ram))
		#	else:
		#		print('RAM allocated in node ' + str(n) + ': ' + str(0))
		#print('Users supported: ' + str(numberUsers(ramNodes)))
		print('Without minimize')
		#if str(sat) == 'sat':
		globalEnergy = m[computationCost].numerator_as_long()/m[computationCost].denominator_as_long() + m[communicationCost].numerator_as_long()/m[communicationCost].denominator_as_long()
		executionTime = m[computationTime].numerator_as_long()/m[computationTime].denominator_as_long() + m[communicationTime].numerator_as_long()/m[communicationTime].denominator_as_long()
			#print('Global energy consumption: ' + str(globalEnergy) + ' (J)')
			#print('Execution time: ' + str(executionTime) + ' (s)')
		print('**************************')
	#


		opt2 = Optimize()

		opt2.add([Sum([If(assignmentOpt [t][m] ,1,0) for m in range(nNodes)]) == 1 for t in range(nTask*nUsers)])
		for t in range(nTask):
			opt2.add(Sum([If(assignmentOpt [t][node] ,  ((tasks[t][7] == 'none') + (tasks[t][7] == nodes[node][11])),1) for node in range(nNodes)]) == nNodes)
			opt2.add(Sum([If(assignment [t][node] ,  ((tasks[t][8] == nodes[node][10])),1) for node in range(nNodes)]) == nNodes)


		#RAM assignmentOpt for each node and user
		for u in range(0, nUsers):
			opt2.add([Sum([assignmentOpt[t+nTask*u][m]*tasks[t+nTask*u][1] for t in range(nTask)]) <= nodes[m][4] for m in range(nNodes)])

		#time restrictions
		for c in range(0, nConstraints):
			opt2.add([(Sum([simplify(assignmentOpt[constraints[c][i]+(u*nTask)][m]*If(assignmentOpt[constraints[c][j]+(u*nTask)][m],0,1)*relation[constraints[c][i]][constraints[c][j]]*1000000/nodes[m][1])for j in range(2, 2 + constraints[c][1])]) + (assignmentOpt[constraints[c][i]+(u*nTask)][m]*tasks[constraints[c][i]+(u*nTask)][0]/nodes[m][0]))*1000000 <= constraints[c][0]*1000000 for i in range(2, 2 + constraints[c][1])  for m in range(nNodes) for u in range(nUsers)])

		#if 'energy' in Objectives:
		opt2.add(communicationCostOpt == Sum([Sum([Sum([Sum([simplify(assignmentOpt[i + u*nTask][m]*If(assignmentOpt[j+ u*nTask][m],0,1)*(nodes[m][2]*(relation[i][j]/nodes[m][1])*nodes[m][5])) for j in range(nTask)]) for i in range(nTask)]) for u in range(nUsers)]) for m in range(nNodes)]))
		opt2.add(computationCostOpt == Sum([Sum([simplify(assignmentOpt[i][m] * nodes[m][3] * tasks[i][0] * (nodes[m][0]**2) *nodes[m][5]) for i in range(nTask*nUsers)]) for m in range(nNodes)]))
		opt2.minimize(communicationCostOpt + computationCostOpt)
		#
		#if 'latency' in Objectives:
		opt2.add(computationTimeOpt == Sum([Sum([If(assignmentOpt[t][m], tasks[t][0]/nodes[m][0],0) for t in range(nTask)]) for m in range (nNodes)]))
		opt2.add(communicationTimeOpt == Sum([Sum([Sum([Sum([simplify(If(assignmentOpt[i + u*nTask][m] * If(assignmentOpt[j+ u*nTask][m],0,1) == 1,relation[i][j]/nodes[m][1],0)) for j in range(nTask)]) for i in range(nTask)]) for u in range(nUsers)]) for m in range(nNodes)]) )
		#opt2.minimize(computationTimeOpt + communicationTimeOpt)

		print('Minimizing ' + str(Objectives))

		#opt2.add(communicationCostOptUser == Sum([Sum([Sum([simplify(assignmentOpt[i + u*nTask][0]*If(assignmentOpt[j+ u*nTask][0],0,1)*(nodes[0][2]*nodes[0][5]*(relation[i][j]/nodes[0][1]))) for j in range(nTask)]) for i in range(nTask)]) for u in range(0,nUsers)]))
		#opt2.add(computationCostOptUser == Sum(Sum([simplify(assignmentOpt[i][0] * nodes[0][3] * tasks[i][0] * (nodes[0][0]**2) *nodes[0][5]) for i in range(nTask*nUsers)])))


		sat = opt2.check()
		m = opt2.model()
		timeAfter = time.time()
		print('**************************')
		print(str(sat) + ' tasks: ' + str(nTask) + ' :' + str(timeAfter-timeBefore))

		#for t in range (nTask):
		#	for n in range (nNodes):
		#		if str(m[assignmentOpt[t][n]]) == 'True':
		#			print('Task ' + str(t) + ' assigned to device ' + str(n))
		#ramNodes = []		
		#for n in range (nNodes):
		#	ram = round(m[RAMresources[n][0]].numerator_as_long()/m[RAMresources[n][0]].denominator_as_long())
		#	ramNodes.append(ram)
		#	if ram > 1:
		#		print('RAM allocated in node ' + str(n) + ': ' + str(ram))
		#	else:
		#		print('RAM allocated in node ' + str(n) + ': ' + str(0))
		#print('Users supported: ' + str(numberUsers(ramNodes)))
		print('Minimizing execution time and energy')
		if str(sat) == 'sat':
			#print('Energy consumption in the DI: ' + str(m[computationCostOpt].numerator_as_long()/m[computationCostOpt].denominator_as_long() + m[communicationCostOpt].numerator_as_long()/m[communicationCostOpt].denominator_as_long() - m[computationCostOptUser].numerator_as_long()/m[computationCostOptUser].denominator_as_long() - m[communicationCostOptUser].numerator_as_long()/m[communicationCostOptUser].denominator_as_long()) + ' (J)')
			optimizedEnergy = m[computationCostOpt].numerator_as_long()/m[computationCostOpt].denominator_as_long() + m[communicationCostOpt].numerator_as_long()/m[communicationCostOpt].denominator_as_long()
			optimizedTime = m[computationTimeOpt].numerator_as_long()/m[computationTimeOpt].denominator_as_long() + m[communicationTimeOpt].numerator_as_long()/m[communicationTimeOpt].denominator_as_long()
			print('Optimized global energy consumption: ' + str(optimizedEnergy) + ' (J)')
			print('Optimized Execution time: ' + str(optimizedTime) + ' (s)')
			energyProfit = ((optimizedEnergy - globalEnergy)/globalEnergy) * 100
			timeProfit = ((optimizedTime - executionTime)/executionTime) * 100

			energyValues.append(energyProfit)
			timeValues.append(timeProfit)
			print('Energy profit: '  + str(energyProfit) + '%')
			print('Time profit: ' + str(timeProfit) + '%')
		#	print('Energy consumption in the user node: ' + str(m[computationCostOptUser].numerator_as_long()/m[computationCostOptUser].denominator_as_long() + m[communicationCostOptUser].numerator_as_long()/m[communicationCostOptUser].denominator_as_long()) + ' (J)')
		print('**************************')
	print('Media valores energía:' + str(row) + str(statistics.mean(energyValues)))
	print('Desviación valores energía:' + str(row) +  str(statistics.stdev(energyValues)))
	print('Media valores tiempo:' + str(row) +  str(statistics.mean(timeValues)))
	print('Desviación valores tiempo:' +  str(row) + str(statistics.stdev(timeValues)))
	globalEnergyMean.append(statistics.mean(energyValues))
	globalEnergyStd.append(statistics.stdev(energyValues))
	globalTimeMean.append(statistics.mean(timeValues))
	globalTimeStd.append(statistics.stdev(timeValues))

print('energy mean: ' + str(globalEnergyMean))
print('energy std: ' + str(globalEnergyStd))
print('time mean: ' + str(globalTimeMean))
print('time std: ' + str(globalTimeStd))