from z3 import *
from random import randint
import random
import time
import string
import statistics

nNativelySupported = Real('nNativelySupported')
nNewSupported = Real('nNewSupported')
nEnabled = Real('nEnabled')


nFeatures = 9
nNodes = 15
nClonable = 4



def randomString(stringLength=2):
	letters = string.ascii_lowercase
	return ''.join(random.choice(letters) for i in range(stringLength))

location = []
sensors = []
peripherals = []
types = ['computing','mote','smartLock']

location.append('edge')
location.append('edge')
location.append('edge')
location.append('edge')
location.append('edge')
sensors.append('')
peripherals.append('')




for x in range(10):
	location.append(randomString(2))

for y in range(1,5):
	sensors.append(randomString(3))
	peripherals.append(randomString(3))



for row in range(10):
	nNodes = 30
	
	nFeatures = row*10 + 10
	nAttributes = round(nFeatures * 0.2)
	nClonable = round(nFeatures * random.uniform(0.1,0.25))
	CMC = []
	enabled = [ Bool("Feature_%s" % (c)) for c in range(nFeatures) ]
	for n in range(nClonable):
		CMC.append({randomString(3): random.uniform(3000000,3500000), randomString(3): random.uniform(2500000,3000000), randomString(3): random.uniform(1000000,2500000), randomString(3):random.uniform(0,1000000)})


	#nClonable = round(nFeatures * random.uniform(0.1,0.25))

	nativelySupported = [ Bool("service_%s" % (c)) for c in range(nFeatures) ]
	newSupported = [ Bool("service_%s" % (c)) for c in range(nFeatures) ]
	#newNodesRequired = [ Bool("newNode_%s" % (c)) for c in range(nFeatures) ]

	attributes = [ [  Real("attribute_%s_%s" % (c,r)) for c in range(2) ] 
      	for r in range(nAttributes) ]

	CMCattributes = [ [ 0 for c in range(2) ] 
		for r in range(nAttributes) ]	

	for c in range(len(CMCattributes)):
		CMCattributes[c][0]= random.uniform(300,35000)
		CMCattributes[c][1]= random.uniform(7000000,7500000)

	times = [ [0 for c in range(5) ] 
		for r in range(8) ]

	features = [ [ 0 for c in range(8) ] 
		for r in range(nFeatures) ]

	nodes = [ [ 0 for c in range(13) ] 
		for r in range(nNodes+1) ]
	featuresName={}

	for experiment in range(5):
		clonable = [[]]
		#{0-CPU, 1-RAM, 2-transmission, 3-sensingRequirements, 4-peripheral requirements, 5-transmit, 6-exactLocation, 7 type }
		for s in range(nFeatures):
			features[s][0] = random.uniform(1000000,3500000)
			features[s][1] = random.uniform(100,300)
			features[s][2] = random.uniform(0,7000)
			features[s][3] = {sensors[round(random.uniform(0,len(sensors)-1))]}
			features[s][4] = {peripherals[round(random.uniform(0,len(peripherals)-1))]}
			features[s][5] = []
			aux = random.uniform(0,100)
			if aux < 60:
				features[s][6] = 'none'
			else:			
				features[s][6] = {location[round(random.uniform(0,len(location)-1))]}
			aux = random.uniform(0,100)
			if aux<50:
				features[s][7] = 'computing'
			elif aux > 50 and aux < 75:
				features[s][7] = 'mote'
			else:
				features[s][7] = 'smartLock'
			numberC = round(random.uniform(0,nClonable-1))
			for i in range(numberC):
				features[s][5].append(i)
			featuresName[str(s)] = randomString(5)


		#{CPU, Bandwidth. Power Upload, k, RAM, policy, Power Download, BandwidthDown,sensing units, peripherals, type, location, owner}
		nodes = [ [ 0 for c in range(13) ] 
			for r in range(nNodes+1) ]


		for n in range(nNodes):
			nodes[n][0] = random.uniform(1000000,3000000)
			nodes[n][1] = random.uniform(0,3500000)
			nodes[n][2] = 0.05
			nodes[n][3] = 0.0001
			nodes[n][4] = random.uniform(0,3500000)
			nodes[n][5] = 1
			nodes[n][6] = 0.05
			nodes[n][7] = 60000
			nodes[n][8] = {peripherals[round(random.uniform(0,len(peripherals)-1))]}
			nodes[n][9] = {sensors[round(random.uniform(0,len(sensors)-1))]}
			aux = random.uniform(0,100)
			if aux<50:
				nodes[n][10] = 'computing'
			elif aux > 50 and aux < 75:
				nodes[n][10] = 'mote'
			else:
				nodes[n][10] = 'smartLock'	
			nodes[n][11] = {location[round(random.uniform(0,len(location)-1))]}
			nodes[n][12] = 'public'



		timeBefore = time.time()


		def maxValue (node,indexDict):
			result = 'Non minimal ' + str(indexDict) + ' supported'
			for key in CMC[indexDict]:
				if(nodes[node][1] >= CMC[indexDict][key]):
					result = key
					break
			return result

		def includeClonable(index, node):
			if (features[index][3] <= nodes[node][9]) and (features[index][4] <= nodes[node][8]):
				newValue = {'Feature: ' + featuresName[str(index)], 'Type: ' + str(nodes[node][10]), 'Node: ' + str(node), 'Location: ' + str(nodes[node][11])}
				for value in features[index][5]:
					newValue.add('Limitations: '  + str(maxValue(node,value)))
				#if(index >= len(clonable)):
				#	clonable.append([])
				#print('tamano ' + str(len(clonable)))
				#print('indice ' + str(index))
				clonable.append(newValue)

			return True

		timeBefore = time.time()

		opt = Optimize()

		for i in range(nFeatures):
			opt.add(If(enabled[i],Sum([If((features[i][3] <= nodes[n][9]) and (features[i][4] <= nodes[n][8]),1,0) for n in range(nNodes)]) >= 1, If(enabled[i],False,True)))
			
		opt.add(nEnabled == Sum([simplify(If(enabled[i], 1, 0)) for i in range(nFeatures)]))
		opt.maximize(nEnabled)

		for n in range(nNodes):
			for i in range(nClonable):
				opt.add(If(enabled[i], includeClonable(i,n),True))

		for c in range(nAttributes):
			opt.add(attributes[c][0] > CMCattributes[c][0])
			opt.add(attributes[c][1] < CMCattributes[c][1])
			opt.minimize(attributes[c][0] )
			opt.maximize(attributes[c][1])



		
		sat = opt.check()

		m = opt.model()
		#print(m)

		timeAfter = time.time()


		timeAfter = time.time()
		#print(str(clonable))
		print(str(sat) + ' features: ' + str(nFeatures) + ' :' + str(timeAfter-timeBefore))
