from z3 import *
from random import randint
import random
import time
import statistics

nEnabled = Real('nEnabled')
communicationTime = Real('communicationTime')
communicationCostDown = Real('communicationCostDown')
computationCost = Real('computationCost')
computationTime = Real('computationTime')
communicationCostUser = Real('communicationCostUser')
communicationDownUser = Real('communicationDownUser')
computationCostUser = Real('computationCostUser')
nFeautures = 4
nNodes = 15
nClonable = 4

enabled = [ Bool("Feature_%s" % (c)) for c in range(nFeautures) ]

clonable = [[]]

print(str(clonable))


features = [ [ 0 for c in range(6) ] 
      for r in range(nFeautures) ]

#{0-CPU, 1-RAM, 2-transmission, 3-sensingRequirements, 4-peripheral requirements, 5-transmit}
#Transmit contains a negative value if the feature doesnt have special requirement to transmit. Else, contains the dictionary with the values
features[0][0] = 15 #Parking
features[0][1] = 0
features[0][2] = 15
features[0][3] = {'parking'}
features[0][4] = {''}
features[0][5] = {}
features[1][0] = 0 #Classroom
features[1][1] = 0
features[1][2] = 0
features[1][3] = {''}
features[1][4] = {'camera', 'microphone'}
features[1][5] = {0}
features[2][0] = 4000 #Environmental
features[2][1] = 15
features[2][2] = {0}
features[2][3] = {'temperature', 'humidity', 'wind'}
features[2][4] = {''}
features[2][5] = {}
features[3][0] = 4000 #Environmental
features[3][1] = 15
features[3][2] = {0}
features[3][3] = {'presence'}
features[3][4] = {''}
features[3][5] = {}


#Clonable and name
featuresName = {'0': 'Smart parking', '1': 'Telematic Classroom', '2': 'Environmental information', '3' : 'Smart office'}


#MATCHING THE FEATURES CONTAINED IN CLONABLE WITH THE ONES CONTAINED IN THE LIST FEATURES (WHICH CONTAINS ALL THE FEATURES)
#key -> clonable id, value -> featureId
featureMatch = {'0': 0, '1' : 1, '2' : 2, '3': 3, '4': 4, '5' : 5, '6' : 6, '7': 7, '8': 8, '9' : 9, '10' : 10, '11': 11, '12' : 12}
	

nodes = [ [ 0 for c in range(12) ] 
	for r in range(nNodes+1) ]

#{0- CPU, 1-BandwidthUp. 2-Power Upload, 3-k, 4-RAM, 5-policy, 6-Power Download, 7-BandwidthDown, 8-peripheralps {}, 9-sensing units {}, 10-type,11-id, 12-owner}
#DEVICES
nodes[0][0] = 1200000000
nodes[0][1] = 5000000
nodes[0][2] = 0.05
nodes[0][3] = 0.0001
nodes[0][4] = 4000.0
nodes[0][5] = 1
nodes[0][6] = 0.05
nodes[0][7] = 60000
nodes[0][8] = {'camera', 'microphone'}
nodes[0][9] = {''}
nodes[0][10] = 'computing'
nodes[0][11] = 'C4'

nodes[1][0] = 1200000000
nodes[1][1] = 3000000
nodes[1][2] = 0.05
nodes[1][3] = 0.0001
nodes[1][4] = 4000.0
nodes[1][5] = 1
nodes[1][6] = 0.05
nodes[1][7] = 60000
nodes[1][8] = {'camera', 'microphone'}
nodes[1][9] = {''}
nodes[1][10] = 'computing'
nodes[1][11] = 'C5'

nodes[2][0] = 1200000000
nodes[2][1] = 1000000
nodes[2][2] = 0.05
nodes[2][3] = 0.0001
nodes[2][4] = 4000.0
nodes[2][5] = 1
nodes[2][6] = 0.05
nodes[2][7] = 60000
nodes[2][8] = {'camera', 'microphone'}
nodes[2][9] = {''}
nodes[2][10] = 'computing'
nodes[2][11] = 'C6'

nodes[3][0] = 1200000000
nodes[3][1] = 4000000
nodes[3][2] = 0.05
nodes[3][3] = 0.0001
nodes[3][4] = 4000.0
nodes[3][5] = 1
nodes[3][6] = 0.05
nodes[3][7] = 60000
nodes[3][8] = {'camera', 'microphone'}
nodes[3][9] = {''}
nodes[3][10] = 'computing'
nodes[3][11] = 'C9'

nodes[4][0] = 1200000000
nodes[4][1] = 3000000
nodes[4][2] = 0.05
nodes[4][3] = 0.0001
nodes[4][4] = 4000.0
nodes[4][5] = 1
nodes[4][6] = 0.05
nodes[4][7] = 60000
nodes[4][8] = {'camera', 'microphone'}
nodes[4][9] = {''}
nodes[4][10] = 'computing'
nodes[4][11] = 'C10'

#PARKING SENSORS
nodes[5][0] = 0
nodes[5][1] = 0
nodes[5][2] = 0.05
nodes[5][3] = 0.0001
nodes[5][4] = 4000.0
nodes[5][5] = 1
nodes[5][6] = 0.05
nodes[5][7] = 60000
nodes[5][8] = {''}
nodes[5][9] = {'parking'}
nodes[5][10] = 'sensing'
nodes[5][11] = 'P1'

nodes[6][0] = 0
nodes[6][1] = 0
nodes[6][2] = 0.05
nodes[6][3] = 0.0001
nodes[6][4] = 4000.0
nodes[6][5] = 1
nodes[6][6] = 0.05
nodes[6][7] = 60000
nodes[6][8] = {''}
nodes[6][9] = {'parking'}
nodes[6][10] = 'sensing'
nodes[6][11] = 'P2'

nodes[7][0] = 0
nodes[7][1] = 0
nodes[7][2] = 0.05
nodes[7][3] = 0.0001
nodes[7][4] = 4000.0
nodes[7][5] = 1
nodes[7][6] = 0.05
nodes[7][7] = 60000
nodes[7][8] = {''}
nodes[7][9] = {'parking'}
nodes[7][10] = 'sensing'
nodes[7][11] = 'P4'

nodes[8][0] = 1200000000
nodes[8][1] = 60000
nodes[8][2] = 0.05
nodes[8][3] = 0.0001
nodes[8][4] = 4000.0
nodes[8][5] = 1
nodes[8][6] = 0.05
nodes[8][7] = 60000
nodes[8][8] = {''}
nodes[8][9] = {'presence'}
nodes[8][10] = 'sensing'
nodes[8][11] = 'D2'

nodes[9][0] = 0
nodes[9][1] = 0
nodes[9][2] = 0.05
nodes[9][3] = 0.0001
nodes[9][4] = 4000.0
nodes[9][5] = 1
nodes[9][6] = 0.05
nodes[9][7] = 60000
nodes[9][8] = {''}
nodes[9][9] = {'presence'}
nodes[9][10] = 'sensing'
nodes[9][11] = 'D5'

nodes[10][0] = 0
nodes[10][1] = 0
nodes[10][2] = 0.05
nodes[10][3] = 0.0001
nodes[10][4] = 4000.0
nodes[10][5] = 1
nodes[10][6] = 0.05
nodes[10][7] = 60000
nodes[10][8] = {''}
nodes[10][9] = {'presence'}
nodes[10][10] = 'sensing'
nodes[10][11] = 'D7'

nodes[11][0] = 0
nodes[11][1] = 0
nodes[11][2] = 0.05
nodes[11][3] = 0.0001
nodes[11][4] = 4000.0
nodes[11][5] = 1
nodes[11][6] = 0.05
nodes[11][7] = 60000
nodes[11][8] = {''}
nodes[11][9] = {'presence'}
nodes[11][10] = 'sensing'
nodes[11][11] = 'D9'

nodes[12][0] = 1200000000
nodes[12][1] = 60000
nodes[12][2] = 0.05
nodes[12][3] = 0.0001
nodes[12][4] = 4000.0
nodes[12][5] = 1
nodes[12][6] = 0.05
nodes[12][7] = 60000
nodes[12][8] = {''}
nodes[12][9] = {'temperature', 'humidity', 'wind'}
nodes[12][10] = 'sensing'
nodes[12][11] = 'M2'

nodes[13][0] = 1200000000
nodes[13][1] = 1700000
nodes[13][2] = 0.05
nodes[13][3] = 0.0001
nodes[13][4] = 4000.0
nodes[13][5] = 1
nodes[13][6] = 0.05
nodes[13][7] = 60000
nodes[13][8] = {'a'}
nodes[13][9] = {'a'}
nodes[13][10] = 'computing'
nodes[13][11] = 'Edge'

nodes[14][0] = 1200000000
nodes[14][1] = 1700000
nodes[14][2] = 0.05
nodes[14][3] = 0.0001
nodes[14][4] = 4000.0
nodes[14][5] = 1
nodes[14][6] = 0.05
nodes[14][7] = 60000
nodes[14][8] = {'a'}
nodes[14][9] = {'a'}
nodes[14][10] = 'computing'
nodes[14][11] = 'Edge'

CMC = []

CMC.append({'1080p': 3600*1024, '720p': 1800*1024, '480p': 1000*1024, '360p': 700*1024})

print(str(clonable[0]))

print(str(next(iter(CMC[0]))))
def maxValue (node,indexDict):
	result = 'Non minimal ' + str(indexDict) + ' supported'
	for key in CMC[indexDict]:
		print('Aqui ha entrado ya: ' + str(key))
		
		print(str(key))
		if(nodes[node][1] >= CMC[indexDict][key]):
			result = key
			break
	return result

def includeClonable(index, node):
	if (features[featureMatch[str(index)]][3] <= nodes[node][9]) and (features[featureMatch[str(index)]][4] <= nodes[node][8]):
		newValue = {'Feature: ' + featuresName[str(index)], 'Type: ' + str(nodes[node][10]), 'Node: ' + str(node), 'Location: ' + str(nodes[node][11])}
		for value in features[featureMatch[str(index)]][5]:
			newValue.add(maxValue(node,value))
		if(index <= len(clonable)):
			clonable.append([])
		clonable[index].append(newValue)	
	return True

#
opt = Optimize()

for i in range(nFeautures):
	opt.add(If(enabled[i],Sum([If((features[i][3] <= nodes[n][9]) and (features[i][4] <= nodes[n][8]),1,0) for n in range(nNodes)]) >= 1, If(enabled[i],False,True)))
	
for n in range(nNodes):
	for i in range(nClonable):
		opt.add(If(enabled[featureMatch[str(i)]], includeClonable(i,n),True))



opt.add(nEnabled == Sum([simplify(If(enabled[i], 1, 0)) for i in range(nFeautures)]))



opt.maximize(nEnabled)
#
print(opt.check())
m = opt.model()
print(m)
print(str(clonable))
