from z3 import *
from random import randint
import time

communicationCost = Real('communicationCost')
communicationCostDown = Real('communicationCostDown')
computationCost = Real('computationCost')
communicationCostUser = Real('communicationCostUser')
communicationDownUser = Real('communicationDownUser')
computationCostUser = Real('computationCostUser')
communicationTime = Real('communicationTime')
computationTime = Real('computationTime')
usuarios = Int('usuarios')

#Objectives = {'energy','latency'}
Objectives = {'energy', 'latency'}

nTask = 21
#todas tareas 19
nUsers = 1
nConstraints = 2
nMeshlium = 2
nNodes = 17

#{task, node}
assignment = [ [ Bool("ASING_%s_%s" % (r,c)) for c in range(nNodes+nUsers-1) ] 
      for r in range(nTask*nUsers) ]

#{node, user}
RAMresources = [ [ Real("RAM_%s_%s" % (r,c)) for c in range(nUsers+nUsers-1) ] 
for r in range(nNodes) ]


#data to be transmitted between tasks
relation = [ [ 0 for c in range(nTask) ] 
      for r in range(nTask) ]

relation[11][12] = 30/8
relation[12][13] = 88064/8
relation[13][14] = 30000/8
relation[14][15] = 1500/8
relation[15][16] = 1550/8
relation[17][18] = 50/8
relation[16][19] = 250/8
relation[18][19] = 250/8

tasks = [ [ 0 for c in range(9) ] 
      for r in range(nTask*nUsers) ]

#{0-CPU, 1-RAM, 2-user, 3-minimal transmission, 4-sensingRequirements, 5-peripheral requirements, 6-transmit, 7-exactLocation, 8 type}
aux = 0
for x in range(0, nUsers):
	tasks[aux+10][0] = 3000 #CameraCalibration
	tasks[aux+10][1] = 10
	tasks[aux+10][2] = x
	tasks[aux+10][3] = 0
	tasks[aux+10][4] = {''}
	tasks[aux+10][5] = {''}
	tasks[aux+10][6] = {}
	tasks[aux+10][7] = 'none'
	tasks[aux+10][8] = 'computing'


	tasks[aux+11][0] = 200 #RequestFrame
	tasks[aux+11][1] = 5
	tasks[aux+11][2] = x
	tasks[aux+11][3] = 0
	tasks[aux+11][4] = {''}
	tasks[aux+11][5] = {''}
	tasks[aux+11][6] = {}
	tasks[aux+11][7] = 'none'
	tasks[aux+11][8] = 'computing'

	tasks[aux+12][0] = 4000 #CaptureFrame
	tasks[aux+12][1] = 15
	tasks[aux+12][2] = x
	tasks[aux+12][3] = 0
	tasks[aux+12][4] = {''}
	tasks[aux+12][5] = {''}
	tasks[aux+12][6] = {}
	tasks[aux+12][7] = 'none'
	tasks[aux+12][8] = 'computing'

	tasks[aux+13][0] = 550000000 #getFeatures
	tasks[aux+13][1] = 30
	tasks[aux+13][2] = x
	tasks[aux+13][3] = 0
	tasks[aux+13][4] = {''}
	tasks[aux+13][5] = {''}
	tasks[aux+13][6] = {}
	tasks[aux+13][7] = 'none'
	tasks[aux+13][8] = 'computing'

	tasks[aux+14][0] = 400000 #poseEstimation
	tasks[aux+14][1] = 30
	tasks[aux+14][2] = x
	tasks[aux+14][3] = 0
	tasks[aux+14][4] = {''}
	tasks[aux+14][5] = {''}
	tasks[aux+14][6] = {}
	tasks[aux+14][7] = 'none'
	tasks[aux+14][8] = 'computing'

	tasks[aux+15][0] = 400000 #consultObject
	tasks[aux+15][1] = 30
	tasks[aux+15][2] = x
	tasks[aux+15][3] = 0
	tasks[aux+15][4] = {''}
	tasks[aux+15][5] = {''}
	tasks[aux+15][6] = {}
	tasks[aux+15][7] = 'none'
	tasks[aux+15][8] = 'computing'

	tasks[aux+16][0] = 40000 #overlayContent
	tasks[aux+16][1] = 90
	tasks[aux+16][2] = x
	tasks[aux+16][3] = 0
	tasks[aux+16][4] = {''}
	tasks[aux+16][5] = {''}
	tasks[aux+16][6] = {}
	tasks[aux+16][7] = 'none'
	tasks[aux+16][8] = 'computing'

	tasks[aux+17][0] = 60000000 #updateMap
	tasks[aux+17][1] = 60
	tasks[aux+17][2] = x
	tasks[aux+17][3] = 0
	tasks[aux+17][4] = {''}
	tasks[aux+17][5] = {''}
	tasks[aux+17][6] = {}
	tasks[aux+17][7] = 'none'
	tasks[aux+17][8] = 'computing'

	tasks[aux+18][0] = 400000 #updateTracker
	tasks[aux+18][1] = 50
	tasks[aux+18][2] = x
	tasks[aux+18][3] = 0
	tasks[aux+18][4] = {''}
	tasks[aux+18][5] = {''}
	tasks[aux+18][6] = {}
	tasks[aux+18][7] = 'none'
	tasks[aux+18][8] = 'computing'

	tasks[aux+19][0] = 700000000 #lookForObjects
	tasks[aux+19][1] = 50
	tasks[aux+19][2] = x
	tasks[aux+19][3] = 0
	tasks[aux+19][4] = {''}
	tasks[aux+19][5] = {''}
	tasks[aux+19][6] = {}
	tasks[aux+19][7] = 'none'
	tasks[aux+19][8] = 'computing'

	tasks[aux+20][0] = 200000 #lookForObjects
	tasks[aux+20][1] = 40
	tasks[aux+20][2] = x
	tasks[aux+20][3] = 0
	tasks[aux+20][4] = {''}
	tasks[aux+20][5] = {''}
	tasks[aux+20][6] = {}
	tasks[aux+20][7] = 'none'
	tasks[aux+20][8] = 'computing'

	tasks[aux+0][0] = 10 #Parking
	tasks[aux+0][1] = 10
	tasks[aux+0][2] = x
	tasks[aux+0][3] = 10
	tasks[aux+0][4] = {'parking'}
	tasks[aux+0][5] = {''}
	tasks[aux+0][6] = {}
	tasks[aux+0][7] = 'P1'
	tasks[aux+0][8] = 'mote'



	tasks[aux +1][0] = 10 #Parking
	tasks[aux +1][1] = 10
	tasks[aux +1][2] = x
	tasks[aux +1][3] = 10
	tasks[aux +1][4] = {'parking'}
	tasks[aux +1][5] = {''}
	tasks[aux +1][6] = {}
	tasks[aux +1][7] = 'P2'
	tasks[aux +1][8] = 'mote'


	tasks[aux+3][0] = 0 #Classroom
	tasks[aux+3][1] = 100
	tasks[aux+3][2] = x
	tasks[aux+3][3] = 1800*1024
	tasks[aux+3][4] = {''}
	tasks[aux+3][5] = {'camera', 'microphone'}
	tasks[aux+3][6] = {0}
	tasks[aux+3][7] = 'C4'
	tasks[aux+3][8] = 'computing'


	tasks[aux+4][0] = 0 #Classroom
	tasks[aux+4][1] = 100
	tasks[aux+4][2] = x
	tasks[aux+4][3] = 1000*1024
	tasks[aux+4][4] = {''}
	tasks[aux+4][5] = {'camera', 'microphone'}
	tasks[aux+4][6] = {0}
	tasks[aux+4][7] = 'C9'
	tasks[aux+4][8] = 'computing'

	tasks[aux +2][0] = 10 #Parking
	tasks[aux +2][1] = 10
	tasks[aux +2][2] = x
	tasks[aux +2][3] = 10
	tasks[aux +2][4] = {'parking'}
	tasks[aux +2][5] = {''}
	tasks[aux +2][6] = {}
	tasks[aux +2][7] = 'P4'
	tasks[aux +2][8] = 'mote'
#	tasks[aux+15][0] = 0 #Classroom
#	tasks[aux+15][1] = 100
#	tasks[aux+15][2] = x
#	tasks[aux+15][3] = 3600*1024
#	tasks[aux+15][4] = {''}
#	tasks[aux+15][5] = {'camera', 'microphone'}
#	tasks[aux+15][6] = {0}
#	tasks[aux+15][7] = 'C1'
#	tasks[aux+15][8] = 'computing'

#tasks[aux+16][0] = 10 #Smart lock
#tasks[aux+16][1] = 10
#tasks[aux+16][2] = x
#tasks[aux+16][3] = 0
#tasks[aux+16][4] = {''}
#tasks[aux+16][5] = {''}
#tasks[aux+16][6] = {0}
#tasks[aux+16][7] = 'C1'
#tasks[aux+16][8] = 'smartLock'

	tasks[aux+8][0] = 10 #Office
	tasks[aux+8][1] = 10
	tasks[aux+8][2] = x
	tasks[aux+8][3] = 0
	tasks[aux+8][4] = {'presence'}
	tasks[aux+8][5] = {''}
	tasks[aux+8][6] = {}
	tasks[aux+8][7] = 'O7'
	tasks[aux+8][8] = 'mote'


	tasks[aux+9][0] = 10 #Environmental
	tasks[aux+9][1] = 10
	tasks[aux+9][2] = x
	tasks[aux+9][3] = 0
	tasks[aux+9][4] = {'temperature', 'humidity', 'wind'}
	tasks[aux+9][5] = {''}
	tasks[aux+9][6] = {}
	tasks[aux+9][7] = 'M2'
	tasks[aux+9][8] = 'mote'


	tasks[aux+7][0] = 10 #Office
	tasks[aux+7][1] = 10
	tasks[aux+7][2] = x
	tasks[aux+7][3] = 0
	tasks[aux+7][4] = {'presence'}
	tasks[aux+7][5] = {''}
	tasks[aux+7][6] = {}
	tasks[aux+7][7] = 'O5'
	tasks[aux+7][8] = 'mote'


	tasks[aux+6][0] = 10 #Office
	tasks[aux+6][1] = 10
	tasks[aux+6][2] = x
	tasks[aux+6][3] = 0
	tasks[aux+6][4] = {'presence'}
	tasks[aux+6][5] = {''}
	tasks[aux+6][6] = {}
	tasks[aux+6][7] = 'O2'
	tasks[aux+6][8] = 'mote'

	tasks[aux+5][0] = 0 #Classroom
	tasks[aux+5][1] = 100
	tasks[aux+5][2] = x
	tasks[aux+5][3] = 1000*1024
	tasks[aux+5][4] = {''}
	tasks[aux+5][5] = {'camera', 'microphone'}
	tasks[aux+5][6] = {0}
	tasks[aux+5][7] = 'C10'
	tasks[aux+5][8] = 'computing'
	aux = aux + nTask


#Edges of the task-call graph
constraints = [ [ 0 for c in range(nTask) ] 
      for r in range(nConstraints) ]

#[0] max time to be executed
#[1] number of tasks involved in the restriction
#[2...n] index of the involved tasks
constraints[0][0] = 0.034
constraints[0][1] = 7
constraints[0][2] = 10
constraints[0][3] = 11
constraints[0][4] = 12
constraints[0][5] = 13
constraints[0][6] = 14
constraints[0][7] = 15
constraints[0][8] = 16
constraints[1][0] = 0.51
constraints[1][1] = 3
constraints[1][2] = 13
constraints[1][3] = 14
constraints[1][4] = 15

nodes = [ [ 0 for c in range(14) ] 
      for r in range(nNodes+nUsers-1) ]

#{0-CPU, 1-Bandwidth. 2-Power Upload, 3-k, 4-RAM, 5-Policy, 6-Power Download, 7-BandwidthDown, 8 -Sensing units, 9- Peripherals, 10-Type, 11- Location, 12-Owner,13 - Communication}
#CMC.append({'1080p': 3600*1024, '720p': 1800*1024, '480p': 1000*1024, '360p': 700*1024})

for x in range(0, nUsers):
	nodes[x][0] = 1800000000
	nodes[x][1] = 200000000
	nodes[x][2] = 0.1
	nodes[x][3] = 0.00023
	nodes[x][4] = 6000
	nodes[x][6] = 0.1
	nodes[x][7] = 250000000
	nodes[x][8] = {''}
	nodes[x][9] = {''}
	nodes[x][10] = 'computing'
	nodes[x][11] = 'user'
	nodes[x][12] = 'public'
	nodes[x][13] = {'wlan'}

nodes[nUsers+0][0] = 2000000000
nodes[nUsers+0][1] = 2500000
nodes[nUsers+0][2] = 0.05
nodes[nUsers+0][3] = 0.0001
nodes[nUsers+0][4] = 2000
nodes[nUsers+0][5] = 1
nodes[nUsers+0][6] = 0.05
nodes[nUsers+0][7] = 60000
nodes[nUsers+0][8] = {'camera', 'microphone'}
nodes[nUsers+0][9] = {''}
nodes[nUsers+0][10] = 'computing'
nodes[nUsers+0][11] = 'C4'
nodes[nUsers+0][12] = 'public'
nodes[nUsers+0][13] = {'wlan'}


#nodes[nUsers+1][0] = 1200000000
#nodes[nUsers+1][1] = 3000000
#nodes[nUsers+1][2] = 0.05
#nodes[nUsers+1][3] = 0.0001
#nodes[nUsers+1][4] = 4000
#nodes[nUsers+1][5] = 1
#nodes[nUsers+1][6] = 0.05
#nodes[nUsers+1][7] = 60000
#nodes[nUsers+1][8] = {'camera', 'microphone'}
#nodes[nUsers+1][9] = {''}
#nodes[nUsers+1][10] = 'computing'
#nodes[nUsers+1][11] = 'C5'
#nodes[nUsers+1][12] = 'public'
#nodes[nUsers+1][13] = {'wlan'}


nodes[nUsers+1][0] = 2000000000
nodes[nUsers+1][1] = 2500000
nodes[nUsers+1][2] = 0.05
nodes[nUsers+1][3] = 0.0001
nodes[nUsers+1][4] = 2000
nodes[nUsers+1][5] = 1
nodes[nUsers+1][6] = 0.05
nodes[nUsers+1][7] = 60000
nodes[nUsers+1][8] = {'camera', 'microphone'}
nodes[nUsers+1][9] = {''}
nodes[nUsers+1][10] = 'computing'
nodes[nUsers+1][11] = 'C6'
nodes[nUsers+1][12] = 'public'
nodes[nUsers+1][13] = {'wlan'}


nodes[nUsers+2][0] = 2000000000
nodes[nUsers+2][1] = 1700000
nodes[nUsers+2][2] = 0.05
nodes[nUsers+2][3] = 0.0001
nodes[nUsers+2][4] = 2000
nodes[nUsers+2][5] = 1
nodes[nUsers+2][6] = 0.05
nodes[nUsers+2][7] = 60000
nodes[nUsers+2][8] = {'camera', 'microphone'}
nodes[nUsers+2][9] = {''}
nodes[nUsers+2][10] = 'computing'
nodes[nUsers+2][11] = 'C9'
nodes[nUsers+2][12] = 'public'
nodes[nUsers+2][13] = {'wlan'}


nodes[nUsers+3][0] = 2000000000
nodes[nUsers+3][1] = 1700000
nodes[nUsers+3][2] = 0.05
nodes[nUsers+3][3] = 0.0001
nodes[nUsers+3][4] = 2000
nodes[nUsers+3][5] = 1
nodes[nUsers+3][6] = 0.05
nodes[nUsers+3][7] = 60000
nodes[nUsers+3][8] = {'camera', 'microphone'}
nodes[nUsers+3][9] = {''}
nodes[nUsers+3][10] = 'computing'
nodes[nUsers+3][11] = 'C10'
nodes[nUsers+3][12] = 'public'
nodes[nUsers+3][13] = {'wlan'}

#PARKInUsers+NG SENSORS
nodes[nUsers+4][0] = 10
nodes[nUsers+4][1] = 10
nodes[nUsers+4][2] = 0.05
nodes[nUsers+4][3] = 0.0001
nodes[nUsers+4][4] = 4000
nodes[nUsers+4][5] = 1
nodes[nUsers+4][6] = 0.05
nodes[nUsers+4][7] = 60000
nodes[nUsers+4][8] = {''}
nodes[nUsers+4][9] = {'parking'}
nodes[nUsers+4][10] = 'mote'
nodes[nUsers+4][11] = 'P1'
nodes[nUsers+4][12] = 'public'
nodes[nUsers+4][13] = {'ble'}


nodes[nUsers+5][0] = 10
nodes[nUsers+5][1] = 10
nodes[nUsers+5][2] = 0.05
nodes[nUsers+5][3] = 0.0001
nodes[nUsers+5][4] = 4000
nodes[nUsers+5][5] = 1
nodes[nUsers+5][6] = 0.05
nodes[nUsers+5][7] = 60000
nodes[nUsers+5][8] = {''}
nodes[nUsers+5][9] = {'parking'}
nodes[nUsers+5][10] = 'mote'
nodes[nUsers+5][11] = 'P2'
nodes[nUsers+5][12] = 'public'
nodes[nUsers+5][13] = {'ble'}


nodes[nUsers+6][0] = 10
nodes[nUsers+6][1] = 10
nodes[nUsers+6][2] = 0.05
nodes[nUsers+6][3] = 0.0001
nodes[nUsers+6][4] = 4000
nodes[nUsers+6][5] = 1
nodes[nUsers+6][6] = 0.05
nodes[nUsers+6][7] = 60000
nodes[nUsers+6][8] = {''}
nodes[nUsers+6][9] = {'parking'}
nodes[nUsers+6][10] = 'mote'
nodes[nUsers+6][11] = 'P4'
nodes[nUsers+6][12] = 'public'
nodes[nUsers+6][13] = {'ble'}


nodes[nUsers+7][0] = 10
nodes[nUsers+7][1] = 10
nodes[nUsers+7][2] = 0.05
nodes[nUsers+7][3] = 0.0001
nodes[nUsers+7][4] = 4000
nodes[nUsers+7][5] = 1
nodes[nUsers+7][6] = 0.05
nodes[nUsers+7][7] = 60000
nodes[nUsers+7][8] = {''}
nodes[nUsers+7][9] = {'presence'}
nodes[nUsers+7][10] = 'mote'
nodes[nUsers+7][11] = 'O2'
nodes[nUsers+7][12] = 'public'
nodes[nUsers+7][13] = {'ble'}


nodes[nUsers+8][0] = 10
nodes[nUsers+8][1] = 10
nodes[nUsers+8][2] = 0.05
nodes[nUsers+8][3] = 0.0001
nodes[nUsers+8][4] = 4000
nodes[nUsers+8][5] = 1
nodes[nUsers+8][6] = 0.05
nodes[nUsers+8][7] = 60000
nodes[nUsers+8][8] = {''}
nodes[nUsers+8][9] = {'presence'}
nodes[nUsers+8][10] = 'mote'
nodes[nUsers+8][11] = 'O5'
nodes[nUsers+8][12] = 'public'
nodes[nUsers+8][13] = {'ble'}


nodes[nUsers+9][0] = 10
nodes[nUsers+9][1] = 10
nodes[nUsers+9][2] = 0.05
nodes[nUsers+9][3] = 0.0001
nodes[nUsers+9][4] = 4000
nodes[nUsers+9][5] = 1
nodes[nUsers+9][6] = 0.05
nodes[nUsers+9][7] = 60000
nodes[nUsers+9][8] = {''}
nodes[nUsers+9][9] = {'presence'}
nodes[nUsers+9][10] = 'mote'
nodes[nUsers+9][11] = 'O7'
nodes[nUsers+9][12] = 'public'
nodes[nUsers+9][13] = {'ble'}


nodes[nUsers+10][0] = 10
nodes[nUsers+10][1] = 10
nodes[nUsers+10][2] = 0.05
nodes[nUsers+10][3] = 0.0001
nodes[nUsers+10][4] = 4000
nodes[nUsers+10][5] = 1
nodes[nUsers+10][6] = 0.05
nodes[nUsers+10][7] = 60000
nodes[nUsers+10][8] = {''}
nodes[nUsers+10][9] = {'presence'}
nodes[nUsers+10][10] = 'mote'
nodes[nUsers+10][11] = 'O9'
nodes[nUsers+10][12] = 'public'
nodes[nUsers+10][13] = {'ble'}


nodes[nUsers+11][0] = 10
nodes[nUsers+11][1] = 10
nodes[nUsers+11][2] = 0.05
nodes[nUsers+11][3] = 0.0001
nodes[nUsers+11][4] = 4000
nodes[nUsers+11][5] = 1
nodes[nUsers+11][6] = 0.05
nodes[nUsers+11][7] = 60000
nodes[nUsers+11][8] = {''}
nodes[nUsers+11][9] = {'temperature', 'humidity', 'wind'}
nodes[nUsers+11][10] = 'mote'
nodes[nUsers+11][11] = 'M2'
nodes[nUsers+11][12] = 'TST-Group'
nodes[nUsers+11][13] = {'ble'}

nodes[nUsers+12][0] = 10
nodes[nUsers+12][1] = 10
nodes[nUsers+12][2] = 0.05
nodes[nUsers+12][3] = 0.0001
nodes[nUsers+12][4] = 4000
nodes[nUsers+12][5] = 1
nodes[nUsers+12][6] = 0.05
nodes[nUsers+12][7] = 60000
nodes[nUsers+12][8] = {''}
nodes[nUsers+12][9] = {'parking'}
nodes[nUsers+12][10] = 'mote'
nodes[nUsers+12][11] = 'P7'
nodes[nUsers+12][12] = 'public'
nodes[nUsers+12][13] = {'ble'}

#nodes[nUsers+13][0] = 10
#nodes[nUsers+13][1] = 10
#nodes[nUsers+13][2] = 0.05
#nodes[nUsers+13][3] = 0.0001
#nodes[nUsers+13][4] = 4000
#nodes[nUsers+13][5] = 1
#nodes[nUsers+13][6] = 0.05
#nodes[nUsers+13][7] = 60000
#nodes[nUsers+13][8] = {''}
#nodes[nUsers+13][9] = {''}
#nodes[nUsers+13][10] = 'smartLock'
#nodes[nUsers+13][11] = 'C1'
#nodes[nUsers+13][12] = 'public'
#nodes[nUsers+13][13] = {'ble'}

#nodes[nUsers+14][0] = 1200000000
#nodes[nUsers+14][1] = 40000000
#nodes[nUsers+14][2] = 0.05
#nodes[nUsers+14][3] = 0.0001
#nodes[nUsers+14][4] = 4000
#nodes[nUsers+14][5] = 1
#nodes[nUsers+14][6] = 0.05
#nodes[nUsers+14][7] = 60000
#nodes[nUsers+14][8] = {'camera', 'microphone'}
#nodes[nUsers+14][9] = {''}
#nodes[nUsers+14][10] = 'computing'
#nodes[nUsers+14][11] = 'C1'
#nodes[nUsers+14][12] = 'public'
#nodes[nUsers+14][13] = {'wlan'}


for x in range(0, nMeshlium):
	nodes[x+13][0] = 180000000
	nodes[x+13][1] = 200000000
	nodes[x+13][2] = 0.1
	nodes[x+13][3] = 0.00023
	nodes[x+13][4] = 2000
	nodes[x+13][6] = 0.1
	nodes[x+13][7] = 250000000
	nodes[x+13][8] = {''}
	nodes[x+13][9] = {''}
	nodes[x+13][10] = 'computing'
	nodes[x+13][11] = 'meshlium ' + str(x)
	nodes[x+13][12] = 'public'
	nodes[x+13][13] = {'ble', 'wlan'}

nodes[15][0] = 240000000
nodes[15][1] = 200000000
nodes[15][2] = 0.1
nodes[15][3] = 0.00023
nodes[15][4] = 6000
nodes[15][6] = 0.1
nodes[15][7] = 250000000
nodes[15][8] = {''}
nodes[15][9] = {''}
nodes[15][10] = 'computing'
nodes[15][11] = 'edge ' + str(1)
nodes[15][12] = 'public'
nodes[15][13] = {'wlan'}

nodes[16][0] = 280000000
nodes[16][1] = 200000000
nodes[16][2] = 0.1
nodes[16][3] = 0.00023
nodes[16][4] = 6000
nodes[16][6] = 0.1
nodes[16][7] = 250000000
nodes[16][8] = {''}
nodes[16][9] = {''}
nodes[16][10] = 'computing'
nodes[16][11] = 'edge ' + str(2)
nodes[16][12] = 'public'
nodes[16][13] = {'wlan'}


#{0-CPU, 1-Bandwidth. 2-Power Upload, 3-k, 4-RAM, 5-Policy, 6-Power Download, 7-BandwidthDown, 8 -Peripheralps, 9- Sensing, 10-Type, 11- Location, 12-Owner,13 - Communication}
#{0-CPU, 1-RAM, 2-user, 3-minimal transmission, 4-sensingRequirements, 5-peripheral requirements, 6-transmit, 7-exactLocation, 8 type}


#def meets (node,task):
#	result = False
#		if task[4] <= nodes[node][8] and  task[5] <= nodes[node][9] and task[6] <= nodes[node][1] and (task[7] == 'none' or task[7] == nodes[node][11]) and task[8] == nodes[node][11]:
#			result = True
#	return result

def getDistance(lat1,lon1,lat2,lon2,connectivity, range):
		R = 6373.0
		dlon = lon2 - lon1
		dlat = lat2 - lat1

		a = sin(dlat / 2)**2 + cos(lat1) * cos(lat2) * sin(dlon / 2)**2
		c = 2 * atan2(sqrt(a), sqrt(1 - a))

		distance = R * c
		available = distance < range

		return available


def numberUsers(RAMSolution):
	minimum = 99999999
	for n in range(1, nNodes):
		if nodes[n][10] == 'computing' and RAMSolution[n] > 0:
			ram = RAMSolution[n]
			if len(nodes[n][11]) <= 3:
				for t in range(nTask):
					if tasks[t][7] == nodes[n][11]:
						ram = ram - tasks[t][1]
			if ram > 0:
					relation = round(nodes[n][4]/ram)
					if relation < minimum:
						minimum = relation
	return minimum


#configuring the policy (user node)
for x in range(nUsers):
	nodes[x][5] = 1

#configuring the policy (rest of nodes). All nodes has been configured with the same node weighting (1)
for x in range(nUsers, nNodes):
	nodes[x][5] = 1


timeBefore = time.time()

opt = Optimize()

opt.add([Sum([If(assignment [t][m] ,1,0) for m in range(nNodes)]) == 1 for t in range(nTask*nUsers)])
for t in range(nTask):
	opt.add(Sum([If(assignment [t][node] , (tasks[t][4] <= nodes[node][9]) *  (tasks[t][5] <= nodes[node][8]) * (tasks[t][3] <= nodes[node][1]) * (tasks[t][8] == nodes[node][10]) * ((tasks[t][7] == 'none') + (tasks[t][7] == nodes[node][11])),1) for node in range(nNodes)]) == nNodes)

opt.add([Sum([If(RAMresources [m][u] >= 0,1,0) for u in range(nUsers)]) == nUsers for m in range(nNodes)])
opt.add([Sum([RAMresources [m][u] for u in range(nUsers)]) <= nodes[m][4] for m in range(nNodes)])

#tasks t11,t13 t17 must be assigned to the user's node
opt.add(Sum([If(assignment [10 + nTask*u][u],1,0)* If(assignment [12 + nTask*u][u],1,0) * If(assignment [16 + nTask*u][u],1,0)  for u in range(nUsers)]) == nUsers)

#RAM assignment for each node and user
for u in range(0, nUsers):
	opt.add([Sum([assignment[t+nTask*u][m]*tasks[t+nTask*u][1] for t in range(nTask)]) <= RAMresources[m][u] for m in range(nNodes)])

#time restrictions
for c in range(0, nConstraints):
	opt.add([(Sum([simplify(assignment[constraints[c][i]+(u*nTask)][m]*If(assignment[constraints[c][j]+(u*nTask)][m],0,1)*relation[constraints[c][i]][constraints[c][j]]*1000000/nodes[m][1])for j in range(2, 2 + constraints[c][1])]) + (assignment[constraints[c][i]+(u*nTask)][m]*tasks[constraints[c][i]+(u*nTask)][0]/nodes[m][0]))*1000000 <= constraints[c][0]*1000000 for i in range(2, 2 + constraints[c][1])  for m in range(nNodes) for u in range(nUsers)])

if 'energy' in Objectives:
	opt.add(communicationCost == Sum([Sum([Sum([Sum([simplify(assignment[i + u*nTask][m]*If(assignment[j+ u*nTask][m],0,1)*(nodes[m][2]*(relation[i][j]/nodes[m][1])*nodes[m][5])) for j in range(nTask)]) for i in range(nTask)]) for u in range(nUsers)]) for m in range(nNodes)]))
	opt.add(computationCost == Sum([Sum([simplify(assignment[i][m] * nodes[m][3] * tasks[i][0] * (nodes[m][0]**2) *nodes[m][5]) for i in range(nTask*nUsers)]) for m in range(nNodes)]))
	opt.add(communicationCostDown == Sum([Sum([Sum([Sum([simplify(assignment[i + u*nTask][m]*If(assignment[j+ u*nTask][m],0,1)*(nodes[m][6]*(relation[j][i]/nodes[m][7])*nodes[m][5])) for j in range(nTask)]) for i in range(nTask)]) for u in range(nUsers)]) for m in range(nNodes)]) )
	opt.minimize(communicationCost + communicationCostDown + computationCost)

if 'latency' in Objectives:
	opt.add(computationTime == Sum([Sum([If(assignment[t][m], tasks[t][0]/nodes[m][0],0) for t in range(nTask)]) for m in range (nNodes)]))
	opt.add(communicationTime == Sum([Sum([Sum([Sum([simplify(If(assignment[i + u*nTask][m] * If(assignment[j+ u*nTask][m],0,1) == 1,relation[i][j]/nodes[m][1],0)) for j in range(nTask)]) for i in range(nTask)]) for u in range(nUsers)]) for m in range(nNodes)]) )

	opt.minimize(computationTime + communicationTime)

#opt.add(usuarios == min([If(nodes[m][10] == 'computing',nodes[m][4]/(RAMresources[m][0]),99999) for m in range(nNodes)]))
#opt.maximize(usuarios)

#COSTES PARA EL USUARIO
opt.add(communicationCostUser == Sum([Sum([Sum([simplify(assignment[i + u*nTask][0]*If(assignment[j+ u*nTask][0],0,1)*(nodes[0][2]*nodes[0][5]*(relation[i][j]/nodes[0][1]))) for j in range(nTask)]) for i in range(nTask)]) for u in range(0,nUsers)]))
opt.add(communicationDownUser == Sum([Sum([Sum([simplify(assignment[i + u*nTask][0]*If(assignment[j+ u*nTask][0],0,1)*(nodes[0][6]*nodes[0][5]*(relation[j][i]/nodes[0][7]))) for j in range(nTask)]) for i in range(nTask)]) for u in range(0,nUsers)]))
opt.add(computationCostUser == Sum(Sum([simplify(assignment[i][0] * nodes[0][3] * tasks[i][0] * (nodes[0][0]**2) *nodes[0][5]) for i in range(nTask*nUsers)])))


timeAfter = time.time()
solution = 1
print('Minimizing ' + str(Objectives))
print('*********SOLUTION************')
solution = solution +1
opt.check()
m = opt.model()
for t in range (nTask):
	for n in range (nNodes):
		if str(m[assignment[t][n]]) == 'True':
			print('Task ' + str(t) + ' assigned to device ' + str(nodes[n][11]))
ramNodes = []		
for n in range (nNodes):
	ram = round(m[RAMresources[n][0]].numerator_as_long()/m[RAMresources[n][0]].denominator_as_long())
	ramNodes.append(ram)
	if ram > 1:
		print('RAM allocated in node ' + str(nodes[n][11]) + ': ' + str(ram))
	else:
		print('RAM allocated in node ' + str(nodes[n][11]) + ': ' + str(0))
print('Users supported: ' + str(numberUsers(ramNodes)))
print('**************************')

print()
#print (sorted ([(d, m[d]) for d in m], key = lambda x: str(x[0])))
print('\n')
#print('Battery level (user node): ' + str(batteryLevel) + '%')
print('Energy consumption in the DI: ' + str(m[computationCost].numerator_as_long()/m[computationCost].denominator_as_long() + m[communicationCost].numerator_as_long()/m[communicationCost].denominator_as_long() + m[communicationCostDown].numerator_as_long()/m[communicationCostDown].denominator_as_long() - m[computationCostUser].numerator_as_long()/m[computationCostUser].denominator_as_long() - m[communicationCostUser].numerator_as_long()/m[communicationCostUser].denominator_as_long()) + ' (J)')
print('Energy consumption in the user node: ' + str(m[computationCostUser].numerator_as_long()/m[computationCostUser].denominator_as_long() + m[communicationCostUser].numerator_as_long()/m[communicationCostUser].denominator_as_long() +  m[communicationDownUser].numerator_as_long()/m[communicationDownUser].denominator_as_long()) + ' (J)')
totalTime = timeAfter - timeBefore
print('Execution time: ' + str(totalTime) + ' (s)')